module EasyApiDoc
  class ApplicationController < ActionController::Base

    before_filter :load_versions
    before_filter :authenticate!
    before_filter :authorize!

    protected

    def authenticate!
      instance_eval &EasyApiDoc::Options.authenticate_with
    end

    def authorize!
      instance_eval &EasyApiDoc::Options.authorize_with
    end

    def load_versions
      @api_versions = EasyApiDoc::ApiVersion.all
    end

    def load_config
      Configuration.load
    end

  end
end
